# encoding: utf-8
      Given(/^I visit the \[(.*)\] page$/) do |page|
        visit(page)
      end

      When(/^(?:I|If I) wait for \((\d+)\) seconds$/) do |amount|
        sleep(amount.to_i)
      end

      When(/^I refresh the page$/) do
        @current_page.refresh
      end

      When(/^I inspect [(\w+)]$/) do |element|
        @current_page.send("#{element}_element").inspect
      end

      When(/^I click on \[(\w+)\]$/) do |object|
        @current_page.send("#{object}_element").when_present.click
      end


      Then(/^I should( not)? see {(.*)} on the page$/) do |negated, text|
        if negated
          expect(@current_page.text).not_to include text
        else
          expect(@current_page.text).to include text
        end
      end

      Then(/^I take a screenshot$/) do
        file = Tempfile.new(['requested_screenshot', '.png'])
        @browser.screenshot.save(file.path)
        attach_file('Requested Screenshot', File.open(file.path))
      end

      Then(/^I pry$/) do
        binding.pry
      end