# encoding: utf-8
# Count References
Then(/^all \[(\w+)\] should be visible$/) do |ref|
  expect { @current_page.ref_to_arr(ref).select(&:visible?).size }.to eventually eql(@current_page.ref_to_arr(ref).size), "#{ref} visibility"
end

Then(/^\((\d+)\) \[(\w+)\] should be visible$/) do |expected, ref|
  expect { @current_page.ref_to_arr(ref).select(&:visible?).size }.to eventually eql(expected.to_i), "#{ref} visibility"
end

Then(/^\((\d+)\) or more \[(\w+)\] should be visible$/) do |expected, ref|
  expect { @current_page.ref_to_arr(ref).select(&:visible?).size }.to eventually be >= (expected.to_i), "#{ref} visibility"
end


# Count Criteria of References
Then(/^\((\d+)\) \[(\w+)\] should have \((\d+)\) \[(\w+)\] visible$/) do |exp_ref, ref, exp_sub_ref, sub_ref|
  expect { @current_page.ref_to_arr(ref).select { |section| section.ref_to_arr(sub_ref).select { |element| element.visible? }.size == exp_sub_ref.to_i }.size }.to eventually eql(exp_ref.to_i), "#{ref} #{sub_ref} visibility"
end

Then(/^\((\d+)\) or more \[(\w+)\] should have \((\d+)\) \[(\w+)\] visible$/) do |exp_ref, ref, exp_sub_ref, sub_ref|
  expect { @current_page.ref_to_arr(ref).select { |section| section.ref_to_arr(sub_ref).select { |element| element.visible? }.size == exp_sub_ref.to_i }.size }.to eventually be >=(exp_ref.to_i), "#{ref} #{sub_ref} visibility"
end

Then(/^\((\d+)\) \[(\w+)\] should have \((\d+)\) or more \[(\w+)\] visible$/) do |exp_ref, ref, exp_sub_ref, sub_ref|
  expect { @current_page.ref_to_arr(ref).select { |section| section.ref_to_arr(sub_ref).select { |element| element.visible? }.size >= exp_sub_ref.to_i }.size }.to eventually eql(exp_ref.to_i), "#{ref} #{sub_ref} visibility"
end

Then(/^\((\d+)\) or more \[(\w+)\] should have \((\d+)\) or more \[(\w+)\] visible$/) do |exp_ref, ref, exp_sub_ref, sub_ref|
  expect { @current_page.ref_to_arr(ref).select { |section| section.ref_to_arr(sub_ref).select { |element| element.visible? }.size >= exp_sub_ref.to_i }.size }.to eventually be >=(exp_ref.to_i), "#{ref} #{sub_ref} visibility"
end

Then(/^all \[(\w+)\] should have \((\d+)\) or more \[(\w+)\] visible$/) do |ref, exp_sub_ref, sub_ref|
  expect { @current_page.ref_to_arr(ref).select { |section| section.ref_to_arr(sub_ref).select { |element| element.visible? }.size >= exp_sub_ref.to_i }.size }.to eventually eql(@current_page.ref_to_arr(ref).size), "#{ref} #{sub_ref} visibility"
end

Then(/^all \[(\w+)\] should have \((\d+)\) \[(\w+)\] visible$/) do |ref, exp_sub_ref, sub_ref|
  expect { @current_page.ref_to_arr(ref).select { |section| section.ref_to_arr(sub_ref).select { |element| element.visible? }.size == exp_sub_ref.to_i }.size }.to eventually eql(@current_page.ref_to_arr(ref).size), "#{ref} #{sub_ref} visibility"
end

Then(/^all \[(\w+)\] should have all \[(\w+)\] visible$/) do |ref, sub_ref|
  expect { @current_page.ref_to_arr(ref).select { |section| section.ref_to_arr(sub_ref).select { |element| element.visible? }.size == sub_ref.to_i }.size }.to eventually eql(@current_page.ref_to_arr(ref).size), "#{ref} #{sub_ref} visibility"
end

# Count Criteria of of Sub-References
Then(/^\((\d+)\) \[(\w+)\] should have \((\d+)\) \[(\w+)\] where \((\d+)\) \[(\w+)\] is visible$/) do |exp_ref, ref, exp_sub_ref, sub_ref, exp_sub_criteria, sub_criteria|
  expect { @current_page.ref_to_arr(ref).select { |section| section.ref_to_arr(sub_ref).select { |section| section.ref_to_arr(sub_criteria).select { |element| element.visible? }.size == exp_sub_criteria.to_i }.size == exp_sub_ref.to_i }.size }.to eventually eq(exp_ref.to_i), "#{ref} #{sub_ref} #{sub_criteria} visibility"
end

Then(/^all \[(\w+)\] should have \((\d+)\) \[(\w+)\] where \((\d+)\) \[(\w+)\] is visible$/) do |ref, exp_sub_ref, sub_ref, exp_sub_criteria, sub_criteria|
  expect { @current_page.ref_to_arr(ref).select { |section| section.ref_to_arr(sub_ref).select { |section| section.ref_to_arr(sub_criteria).select { |element| element.visible? }.size == exp_sub_criteria.to_i }.size == exp_sub_ref.to_i }.size }.to eventually eql(@current_page.ref_to_arr(ref).size), "#{ref} #{sub_ref} #{sub_criteria} visibility"
end

Then(/^\((\d+)\) \[(\w+)\] should have all \[(\w+)\] where \((\d+)\) \[(\w+)\] is visible$/) do |exp_ref, ref, sub_ref, exp_sub_criteria, sub_criteria|
  expect { @current_page.ref_to_arr(ref).select { |section| section.ref_to_arr(sub_ref).select { |section| section.ref_to_arr(sub_criteria).select { |element| element.visible? }.size == exp_sub_criteria.to_i }.size == section.ref_to_arr(sub_ref).size }.size }.to eventually eql(exp_ref.to_i), "#{ref} #{sub_ref} #{sub_criteria} visibility"
end


# Element within a Page Section within a Page Section should contain text
Then(/^(?:the |)\[(\w+)\] \[(\w+)\] \[(\w+)\] should include the text {(.*)}$/) do |ref, sub_ref, sub_sub_ref, expected|
  expect { @current_page.ref_to_arr(ref).map {|r| r.ref_to_arr(sub_ref)}.map {|sr| sr.ref_to_arr(sub_sub_ref)}.flatten.map {|e| e.attribute('textContent')} }.to eventually all include(expected)
end

# Element within a Page Section should contain text
Then(/^(?:the |)\[(\w+)\] \[(\w+)\] should include the text {(.*)}$/) do |ref, sub_ref, expected|
  expect { @current_page.ref_to_arr(ref).map {|r| r.ref_to_arr(sub_ref)}.flatten.map {|e| e.attribute('textContent')} }.to eventually all include(expected)
end

# Element should contain text
Then(/^(?:the |)\[(\w+)\] should include the text {(.*)}$/) do |ref, expected|
  expect { @current_page.ref_to_arr(ref).map {|e| e.attribute('textContent')} }.to eventually all include(expected)
end


# E/Es/PS/PSs should be enabled
Then(/^the \[(\w+)\] should be enabled$/) do |ref|
  expect { @current_page.ref_to_arr(ref) }.to eventually all be_enabled
end

# E/Es/PS/PSs should be disabled
Then(/^the \[(\w+)\] should be disabled$/) do |ref|
  expect { @current_page.ref_to_arr(ref).map { |e| e.exists? && e.enabled? } }.to eventually_not include be_truthy
end

# E/Es/PS/PSs within PS/PSs should be enabled
Then(/^the \[(\w+)\] \[(\w+)\] should be enabled$/) do |ref, sub_ref|
  expect { @current_page.ref_to_arr(ref).flat_map { |section| section.ref_to_arr(sub_ref) }.select(&:enabled?) }.to eventually all be_truthy
end

# E/Es/PS/PSs within PS/PSs should be disabled
Then(/^the \[(\w+)\] \[(\w+)\] should be disabled$/) do |ref, sub_ref|
  expect { @current_page.ref_to_arr(ref).flat_map { |section| section.ref_to_arr(sub_ref) }.select(&:enabled?) }.to eventually_not all be_truthy
end